pangomm: Pango Namespace Reference

pangomm 2.52.0

Classes | Typedefs | Enumerations | Functions | Variables
Pango Namespace Reference

## Classes
class | Analysis
| A Pango::Analysis stores information about the properties of a segment of text. More...
class | AttrColor
| A Pango::AttrColor is used to represent an attribute which is a color. More...
class | AttrFloat
| A Pango::AttrFloat is used to represent an attribute with a float or double value. More...
class | AttrFontDesc
| A Pango::AttrFontDesc is used to represent an attribute that sets all aspects of the font description at once. More...
class | Attribute
| The Pango::Attribute structure represents the common portions of all attributes. More...
struct | AttributeTraits
class | AttrInt
| A Pango::AttrInt is used to represent an attribute with an integer or enumeration value. More...
class | AttrIter
| A Pango::AttrIter is used to represent an iterator through a Pango::AttrList. More...
class | AttrLanguage
| A Pango::AttrLanguage is used to represent an attribute that is a language. More...
class | AttrList
| A Pango::AttrList represents a list of attributes that apply to a section of text. More...
class | AttrShape
| A Pango::AttrShape structure is used to represent an attribute which imposes shape restrictions. More...
class | AttrString
| A Pango::AttrString is used to represent an attribute with a string value. More...
class | BaselineShift_Wrapper
| Wrapper for enum BaselineShift. More...
class | CairoFontMap
| Pango::CairoFontMap is an interface implemented by font maps for use with Cairo. More...
class | CairoFontMapImpl
| Gdk::CairoFontMapImpl is a Pango::FontMap that implements the Pango::CairoFontMap interface. More...
class | Color
| A Pango::Color is used to represent a color in an uncalibrated RGB colorspace. More...
class | Context
| A Pango::Context stores global information used to control the itemization process. More...
class | Coverage
| A Pango::Coverage represents a map from ISO-10646 character point to Pango::Coverage::Level. More...
class | Font
| A Pango::Font is used to represent a font in a rendering-system-independent matter. More...
class | FontDescription
| A Pango::FontDescription represents the description of an ideal font. More...
class | FontFace
| A Pango::FontFace is used to represent a group of fonts with the same family, slant, weight, width, but varying sizes. More...
class | FontFamily
| A Pango::FontFamily is used to represent a family of related font faces. More...
class | FontMap
| A Pango::FontMap represents the set of fonts available for a particular rendering system. More...
class | FontMetrics
| A Pango::FontMetrics holds the overall metric information for a font (possibly restricted to a script). More...
class | Fontset
| A Pango::Fontset is used to represent a set of fonts. More...
class | GlyphGeometry
| A Pango::GlyphGeometry contains width and positioning information for a single glyph. More...
class | GlyphInfo
| A Pango::GlyphInfo represents a single glyph together with positioning information and visual attributes. More...
class | GlyphItem
| A Pango::GlyphItem is a pair of a Pango::Item and the glyphs resulting from shaping the text corresponding to an item. More...
class | GlyphString
| A Pango::GlyphString is used to store strings of glyphs with geometry and visual attribute information. More...
class | Item
| A Pango::Item stores information about a segment of text. More...
class | Language
| A Pango::Language is used to represent a language. More...
class | Layout
| A Pango::Layout represents an entire paragraph of text. More...
class | LayoutIter
| A Pango::LayoutIter can be used to iterate over the visual extents of a Pango::Layout. More...
class | LayoutLine
| A Pango::LayoutLine represents one of the lines resulting from laying out a paragraph via Pango::Layout. More...
class | Rectangle
| A Pango::Rectangle represents a rectangle. More...
class | Renderer
| Pango::Renderer is a base class that contains the necessary logic for rendering a Pango::Layout or Pango::LayoutLine. More...
class | TabArray
| A Pango::TabArray contains an array of tab stops. More...
class | Weight_Wrapper
| Wrapper for enum Weight. More...

## Typedefs
typedef PangoMatrix | Matrix
using | BaselineShift = BaselineShift_Wrapper::BaselineShift
| BaselineShift enumerators are scoped by the wrapper class and can be implicitly converted to int. More...
typedef PangoLogAttr | LogAttr
| A Pango::LogAttr stores information about the attributes of a single character. More...
using | Weight = Weight_Wrapper::Weight
| Weight enumerators are scoped by the wrapper class and can be implicitly converted to int. More...
typedef PangoGlyph | Glyph
| A Pango::Glyph represents a single glyph in the output form of a string. More...
typedef PangoGlyphUnit | GlyphUnit
| A Pango::GlyphUnit is used to store dimensions within Pango. More...
typedef PangoGlyphVisAttr | GlyphVisAttr
| A Pango::GlyphVisAttr is used to communicate information between the shaping phase and the rendering phase. More...

## Enumerations
enum class | AttrType { AttrType::INVALID , AttrType::LANGUAGE , AttrType::FAMILY , AttrType::STYLE , AttrType::WEIGHT , AttrType::VARIANT , AttrType::STRETCH , AttrType::SIZE , AttrType::FONT_DESC , AttrType::FOREGROUND , AttrType::BACKGROUND , AttrType::UNDERLINE , AttrType::STRIKETHROUGH , AttrType::RISE , AttrType::SHAPE , AttrType::SCALE_FACTOR , AttrType::FALLBACK , AttrType::LETTER_SPACING , AttrType::UNDERLINE_COLOR , AttrType::STRIKETHROUGH_COLOR , AttrType::ABSOLUTE_SIZE , AttrType::GRAVITY , AttrType::GRAVITY_HINT , AttrType::FONT_FEATURES , AttrType::FOREGROUND_ALPHA , AttrType::BACKGROUND_ALPHA , AttrType::ALLOW_BREAKS , AttrType::SHOW , AttrType::INSERT_HYPHENS , AttrType::OVERLINE , AttrType::OVERLINE_COLOR , AttrType::LINE_HEIGHT , AttrType::ABSOLUTE_LINE_HEIGHT , AttrType::TEXT_TRANSFORM , AttrType::WORD , AttrType::SENTENCE , AttrType::BASELINE_SHIFT , AttrType::FONT_SCALE }
| The `Pango::AttrType` distinguishes between different types of attributes. More...
enum class | Underline { Underline::NONE , Underline::SINGLE , Underline::DOUBLE , Underline::LOW , Underline::ERROR , Underline::SINGLE_LINE , Underline::DOUBLE_LINE , Underline::ERROR_LINE }
| The `Pango::Underline` enumeration is used to specify whether text should be underlined, and if so, the type of underlining. More...
enum class | Overline { Overline::NONE , Overline::SINGLE }
| The `Pango::Overline` enumeration is used to specify whether text should be overlined, and if so, the type of line. More...
enum class | ShowFlags { ShowFlags::NONE = 0x0 , ShowFlags::SPACES = 1 << 0 , ShowFlags::LINE_BREAKS = 1 << 1 , ShowFlags::IGNORABLES = 1 << 2 }
| These flags affect how Pango treats characters that are normally not visible in the output. More...
enum class | TextTransform { TextTransform::NONE , TextTransform::LOWERCASE , TextTransform::UPPERCASE , TextTransform::CAPITALIZE }
| An enumeration that affects how Pango treats characters during shaping. More...
enum class | FontScale { FontScale::NONE , FontScale::SUPERSCRIPT , FontScale::SUBSCRIPT , FontScale::SMALL_CAPS }
| An enumeration that affects font sizes for superscript and subscript positioning and for (emulated) Small Caps. More...
enum class | Direction { Direction::LTR , Direction::RTL , Direction::TTB_LTR , Direction::TTB_RTL , Direction::WEAK_LTR , Direction::WEAK_RTL , Direction::NEUTRAL }
| `Pango::Direction` represents a direction in the Unicode bidirectional algorithm. More...
enum class | GravityHint { GravityHint::NATURAL , GravityHint::STRONG , GravityHint::LINE }
| `Pango::GravityHint` defines how horizontal scripts should behave in a vertical context. More...
enum class | Style { Style::NORMAL , Style::OBLIQUE , Style::ITALIC }
| An enumeration specifying the various slant styles possible for a font. More...
enum class | Variant { Variant::NORMAL , Variant::SMALL_CAPS , Variant::ALL_SMALL_CAPS , Variant::PETITE_CAPS , Variant::ALL_PETITE_CAPS , Variant::UNICASE , Variant::TITLE_CAPS }
| An enumeration specifying capitalization variant of the font. More...
enum class | Stretch { Stretch::ULTRA_CONDENSED , Stretch::EXTRA_CONDENSED , Stretch::CONDENSED , Stretch::SEMI_CONDENSED , Stretch::NORMAL , Stretch::SEMI_EXPANDED , Stretch::EXPANDED , Stretch::EXTRA_EXPANDED , Stretch::ULTRA_EXPANDED }
| An enumeration specifying the width of the font relative to other designs within a family. More...
enum class | FontMask { FontMask::FAMILY = 1 << 0 , FontMask::STYLE = 1 << 1 , FontMask::VARIANT = 1 << 2 , FontMask::WEIGHT = 1 << 3 , FontMask::STRETCH = 1 << 4 , FontMask::SIZE = 1 << 5 , FontMask::GRAVITY = 1 << 6 , FontMask::VARIATIONS = 1 << 7 }
| The bits in a `Pango::FontMask` correspond to the set fields in a `Pango::FontDescription`. More...
enum class | Gravity { Gravity::SOUTH , Gravity::EAST , Gravity::NORTH , Gravity::WEST , Gravity::AUTO }
| `Pango::Gravity` represents the orientation of glyphs in a segment of text. More...
enum class | ShapeFlags { ShapeFlags::NONE = 0x0 , ShapeFlags::ROUND_POSITIONS = 1 << 0 }
| Flags influencing the shaping process. More...
enum class | Script { Script::INVALID_CODE = -1 , Script::COMMON , Script::INHERITED , Script::ARABIC , Script::ARMENIAN , Script::BENGALI , Script::BOPOMOFO , Script::CHEROKEE , Script::COPTIC , Script::CYRILLIC , Script::DESERET , Script::DEVANAGARI , Script::ETHIOPIC , Script::GEORGIAN , Script::GOTHIC , Script::GREEK , Script::GUJARATI , Script::GURMUKHI , Script::HAN , Script::HANGUL , Script::HEBREW , Script::HIRAGANA , Script::KANNADA , Script::KATAKANA , Script::KHMER , Script::LAO , Script::LATIN , Script::MALAYALAM , Script::MONGOLIAN , Script::MYANMAR , Script::OGHAM , Script::OLD_ITALIC , Script::ORIYA , Script::RUNIC , Script::SINHALA , Script::SYRIAC , Script::TAMIL , Script::TELUGU , Script::THAANA , Script::THAI , Script::TIBETAN , Script::CANADIAN_ABORIGINAL , Script::YI , Script::TAGALOG , Script::HANUNOO , Script::BUHID , Script::TAGBANWA , Script::BRAILLE , Script::CYPRIOT , Script::LIMBU , Script::OSMANYA , Script::SHAVIAN , Script::LINEAR_B , Script::TAI_LE , Script::UGARITIC , Script::NEW_TAI_LUE , Script::BUGINESE , Script::GLAGOLITIC , Script::TIFINAGH , Script::SYLOTI_NAGRI , Script::OLD_PERSIAN , Script::KHAROSHTHI , Script::UNKNOWN , Script::BALINESE , Script::CUNEIFORM , Script::PHOENICIAN , Script::PHAGS_PA , Script::NKO , Script::KAYAH_LI , Script::LEPCHA , Script::REJANG , Script::SUNDANESE , Script::SAURASHTRA , Script::CHAM , Script::OL_CHIKI , Script::VAI , Script::CARIAN , Script::LYCIAN , Script::LYDIAN , Script::BATAK , Script::BRAHMI , Script::MANDAIC , Script::CHAKMA , Script::MEROITIC_CURSIVE , Script::MEROITIC_HIEROGLYPHS , Script::MIAO , Script::SHARADA , Script::SORA_SOMPENG , Script::TAKRI , Script::BASSA_VAH , Script::CAUCASIAN_ALBANIAN , Script::DUPLOYAN , Script::ELBASAN , Script::GRANTHA , Script::KHOJKI , Script::KHUDAWADI , Script::LINEAR_A , Script::MAHAJANI , Script::MANICHAEAN , Script::MENDE_KIKAKUI , Script::MODI , Script::MRO , Script::NABATAEAN , Script::OLD_NORTH_ARABIAN , Script::OLD_PERMIC , Script::PAHAWH_HMONG , Script::PALMYRENE , Script::PAU_CIN_HAU , Script::PSALTER_PAHLAVI , Script::SIDDHAM , Script::TIRHUTA , Script::WARANG_CITI , Script::AHOM , Script::ANATOLIAN_HIEROGLYPHS , Script::HATRAN , Script::MULTANI , Script::OLD_HUNGARIAN , Script::SIGNWRITING }
| The `Pango::Script` enumeration identifies different writing systems. More...
enum class | Alignment { Alignment::LEFT , Alignment::CENTER , Alignment::RIGHT }
| `Pango::Alignment` describes how to align the lines of a `Pango::Layout` within the available space. More...
enum class | WrapMode { WrapMode::WORD , WrapMode::CHAR , WrapMode::WORD_CHAR }
| `Pango::WrapMode` describes how to wrap the lines of a `Pango::Layout` to the desired width. More...
enum class | EllipsizeMode { EllipsizeMode::NONE , EllipsizeMode::START , EllipsizeMode::MIDDLE , EllipsizeMode::END }
| `Pango::EllipsizeMode` describes what sort of ellipsization should be applied to text. More...
enum class | TabAlign { TabAlign::LEFT , TabAlign::RIGHT , TabAlign::CENTER , TabAlign::DECIMAL }
| `Pango::TabAlign` specifies where the text appears relative to the tab stop position. More...

## Functions
void | init ()
| Initialize pangomm. More...
ShowFlags | operator| (ShowFlags lhs, ShowFlags rhs)
ShowFlags | operator& (ShowFlags lhs, ShowFlags rhs)
ShowFlags | operator^ (ShowFlags lhs, ShowFlags rhs)
ShowFlags | operator~ (ShowFlags flags)
ShowFlags & | operator|= (ShowFlags & lhs, ShowFlags rhs)
ShowFlags & | operator&= (ShowFlags & lhs, ShowFlags rhs)
ShowFlags & | operator^= (ShowFlags & lhs, ShowFlags rhs)
FontMask | operator| (FontMask lhs, FontMask rhs)
FontMask | operator& (FontMask lhs, FontMask rhs)
FontMask | operator^ (FontMask lhs, FontMask rhs)
FontMask | operator~ (FontMask flags)
FontMask & | operator|= (FontMask & lhs, FontMask rhs)
FontMask & | operator&= (FontMask & lhs, FontMask rhs)
FontMask & | operator^= (FontMask & lhs, FontMask rhs)
ShapeFlags | operator| (ShapeFlags lhs, ShapeFlags rhs)
ShapeFlags | operator& (ShapeFlags lhs, ShapeFlags rhs)
ShapeFlags | operator^ (ShapeFlags lhs, ShapeFlags rhs)
ShapeFlags | operator~ (ShapeFlags flags)
ShapeFlags & | operator|= (ShapeFlags & lhs, ShapeFlags rhs)
ShapeFlags & | operator&= (ShapeFlags & lhs, ShapeFlags rhs)
ShapeFlags & | operator^= (ShapeFlags & lhs, ShapeFlags rhs)

## Variables
const int | SCALE = 1024
const double | SCALE_XX_SMALL = 0.5787037037037
const double | SCALE_X_SMALL = 0.6444444444444
const double | SCALE_SMALL = 0.8333333333333
const double | SCALE_MEDIUM = 1.0
const double | SCALE_LARGE = 1.2
const double | SCALE_X_LARGE = 1.4399999999999
const double | SCALE_XX_LARGE = 1.728

## Typedef Documentation

## ◆ Glyph

typedef PangoGlyph Pango::Glyph

A Pango::Glyph represents a single glyph in the output form of a string.

## ◆ GlyphUnit

typedef PangoGlyphUnit Pango::GlyphUnit

A Pango::GlyphUnit is used to store dimensions within Pango.

Dimensions are stored in 1/64ths of a point.

## ◆ GlyphVisAttr

typedef PangoGlyphVisAttr Pango::GlyphVisAttr

A Pango::GlyphVisAttr is used to communicate information between the shaping phase and the rendering phase.

It's contents are still evolving.

## ◆ LogAttr

typedef PangoLogAttr Pango::LogAttr

A Pango::LogAttr stores information about the attributes of a single character.

## ◆ Matrix

typedef PangoMatrix Pango::Matrix

## Function Documentation

## ◆ init()

void Pango::init | ( |  | ) |

Initialize pangomm.

You may call this more than once. You do not need to call this if you are using Gtk::Main, because it calls it for you.

## Variable Documentation

## ◆ SCALE

const int Pango::SCALE = 1024

## ◆ SCALE_LARGE

const double Pango::SCALE_LARGE = 1.2

## ◆ SCALE_MEDIUM

const double Pango::SCALE_MEDIUM = 1.0

## ◆ SCALE_SMALL

const double Pango::SCALE_SMALL = 0.8333333333333

## ◆ SCALE_X_LARGE

const double Pango::SCALE_X_LARGE = 1.4399999999999

## ◆ SCALE_X_SMALL

const double Pango::SCALE_X_SMALL = 0.6444444444444

## ◆ SCALE_XX_LARGE

const double Pango::SCALE_XX_LARGE = 1.728

## ◆ SCALE_XX_SMALL

const double Pango::SCALE_XX_SMALL = 0.5787037037037